//led.cpp - LED library.
//Copyright (c) 2018, Julie Gonzales VK3FOWL and Joe Gonzales VK3YSP.
//Released under the GNU General Public License.

#include "led.h"
#include "timer.h"
#include "arduino.h"

Led::Led(int pin){
  _pin = pin;
  pinMode(_pin, OUTPUT);
  digitalWrite(_pin, LOW);
}

void Led::on() {
  digitalWrite(_pin, HIGH);
}

void Led::off() {
  digitalWrite(_pin, LOW);
}

void Led::state(bool state) {
  if (state) {
    on();
  } else {
    off() ;
  }
}

void Led::flash(long onTime, long offTime) {
  long cycleTime = onTime + offTime;
  long cyclePoint = _t1.elapsed() % cycleTime;
  if (cyclePoint < onTime){
    on();
  } else {
    off();
  }
}

