//switch.cpp - Switch library.
//Copyright (c) 2018, Julie Gonzales VK3FOWL and Joe Gonzales VK3YSP.
//Released under the GNU General Public License.

#include "switch.h"
#include "arduino.h"

Switch::Switch(int pin, int type) {
  _pin = pin;
  _state = false;
  _type = type;
  _pass = 0;
  _count = 0;
  pinMode(_pin, INPUT_PULLUP);  //This provides an internal pullup for a switch to GND.
}

bool Switch::_switch() {
  return not digitalRead(_pin); //The switch state is the opposite of the pin state
}

bool Switch::state() {
  if (_type == Press) {
    _state = _switch();
    return _state;
  }
  if (_type == Toggle) {
    if (_switch() == true) {    //The switch is on
      if (_pass < Pass) {
        _pass++;
        if (_pass == Pass) {    //The threshold is reached for the first time
          _state = not _state;  //Toggle the state of the switch
          _count++;             //Increment the switch count
        }
      }
    } else {                    //The switch is off
      _pass = 0;                //Reset the pass counter
    }
  }
  return (_state);              //Return the current state of the switch
}






