//timer.cpp - Timer library.
//Copyright (c) 2018, Julie Gonzales VK3FOWL and Joe Gonzales VK3YSP.
//Released under the GNU General Public License.

#include "timer.h"
#include "arduino.h"

Timer::Timer(void) {
  reset();
}

Timer::Timer(long period) {
  _period = period;
  reset();
}

void Timer::reset() {
  _start = millis();
}

void Timer::reset(long period) {
  _period = period;
  _start = millis();
}

long Timer::elapsed() {
  return millis() - _start;
}

long Timer::periods() {
  return long(elapsed() / _period);
}

bool Timer::timeout() {
  return (elapsed() > _period);
}

bool Timer::toggle() {
  return (periods() % 2);
}

